﻿/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

SET @saved_cs_client     = @@character_set_client; 
SET character_set_client = utf8; 

drop table IF EXISTS `libavtorname`;
drop table IF EXISTS `libseqname`;

rename table `libavtors` to `libavtorname`;
rename table `libseqs` to `libseqname`;

ALTER ignore TABLE `libavtor` CHANGE `bid` `bookid` int(10);
ALTER ignore TABLE `libavtor` CHANGE `aid` `avtorid` int(10);
ALTER ignore TABLE `libavtorname` CHANGE `aid` `avtorid` int(10);
ALTER ignore TABLE `libbook` CHANGE `bid` `bookid` int(10);
ALTER ignore TABLE `libfilename` CHANGE `bid` `bookid` int(10);
ALTER ignore TABLE `libgenre` CHANGE `bid` `bookid` int(10);
ALTER ignore TABLE `libgenre` CHANGE `gid` `genreid` int(10);
ALTER ignore TABLE `libgenres` CHANGE `gid` `genreid` int(10);
ALTER ignore TABLE `libgenres` CHANGE `gdesc` `genredesc` varchar(99);
ALTER ignore TABLE `libgenres` CHANGE `code` `genrecode` varchar(45);
ALTER ignore TABLE `libgenres` CHANGE `gidm` `parentgenreid` int(10);
ALTER ignore TABLE `libseq` CHANGE `bid` `bookid` int(11);
ALTER ignore TABLE `libseq` CHANGE `sid` `seqid` int(11);
ALTER ignore TABLE `libseq` CHANGE `sn` `seqnumb` int(11);
ALTER ignore TABLE `libseqname` CHANGE `sid` `seqid` int(11);
UPDATE IGNORE libgenres SET parentgenreid=NULL WHERE parentgenreid=0;

drop table if exists libavtoraliase;
drop table if exists mlauthoraliase;
-- Основная таблица ------------------------------------------------------------------------------------------

DROP TABLE IF EXISTS `mlbook`;
CREATE TABLE `mlbook` (
  `bookid` int(11) NOT NULL auto_increment,          -- [*]   ИД книги в базе
  `library` varchar(64) NOT NULL DEFAULT '',         -- [*]   Библиотека
  `title` varchar(255) NOT NULL DEFAULT '',          -- [1]   Название книги
  `lang` varchar(10) NOT NULL DEFAULT '',            -- [1]   Язык книги
  `date_in` DATETIME,                                -- [*]   Дата поступления
  `filename` varchar(255) NOT NULL DEFAULT '',       -- [*]   Имя файла
  `filesize` int(11) NOT NULL default 0,             -- [*]   Если FB2 - размер без архивации
  `arcname` varchar(255) NOT NULL DEFAULT '',        -- [*]   Имя файла
  `ext` varchar(5) NOT NULL DEFAULT '',              -- [*]   Расширение
  `deleted` char(1) NOT NULL DEFAULT '',             -- [*]   Удалено (для Librus, Flibusta)
  `md5` char(32) NOT NULL DEFAULT '',                -- [*]   MD5
  `srclang` varchar(10) NOT NULL DEFAULT '',         -- [0,1] язык, на котором исходно написана книга, то есть язык до перевода
  `date_wr` char(32) default '',                     -- [0,1] Дата написания книги Из FB2
  `keywords` varchar(255) NOT NULL DEFAULT '',       -- [0,1] Из FB2
  `di_progused` varchar(255) NOT NULL DEFAULT '',    -- [0,1] В какой программе изготовлено
  `di_date` char(32) default '',                     -- [1]   Дата создания документа
  `di_srcurl` varchar(255) NOT NULL DEFAULT '',      -- [0,n] URL страницы, откуда взят текст для подготовки документа
  `di_srcosr` varchar(100) NOT NULL DEFAULT '',      -- [0,1] автор текста, который был использован при подготовке документа
  `di_author` varchar(100) NOT NULL DEFAULT '',      -- [1,n] автор документа
  `di_id` varchar(254) NOT NULL DEFAULT '',          -- [1]   уникальный идентификатор документа FB2
  `di_version` varchar(10) NOT NULL DEFAULT '',      -- [1]   Версия документа
  `pi_bookname` varchar(255) NOT NULL DEFAULT '',    -- [0,1] название оригинальной (бумажной) книги
  `pi_publisher` varchar(100) NOT NULL DEFAULT '',   -- [0,1] название издательства
  `pi_city` varchar(50) NOT NULL DEFAULT '',         -- [0,1] город, в котором издана книга
  `pi_year` varchar(10) NOT NULL DEFAULT '',         -- [0,1] год издания книги
  `pi_isbn` varchar(100) NOT NULL DEFAULT '',        -- [0,1] ISBN издания
-- pi_sequence  [0,n]
   PRIMARY KEY  (`bookid`),
   KEY `md5` (`md5`),
   KEY `ext` (`ext`),
   KEY `lang` (`lang`),
   KEY `deleted` (`deleted`),
   KEY `filename` (`filename`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

insert ignore into mlbook select `bookid`,Database(),`Title`,lower(`Lang`),`Time`,'',`Filesize`,'',lower(`FileType`),`Deleted`,lower(`md5`),srclang,'',`keywords`,'','','','',`FileAuthor`,'',`Ver`,'','','',`Year`,'' from libbook;

UPDATE IGNORE mlbook AS a, libfilenameold AS b SET a.filename=b.filename WHERE a.bookid=b.bookid;
UPDATE IGNORE mlbook AS a, libfilename AS b SET a.filename=b.filename WHERE a.bookid=b.bookid;
UPDATE IGNORE mlbook SET filename=bookid WHERE filename='' AND ext='fb2';
UPDATE IGNORE mlbook SET filename=CONCAT(bookid,'.',ext) WHERE filename='' AND ext<>'fb2';


-- Дополнтельная информация  ----------------------------------------------------------------------------
  
DROP TABLE IF EXISTS `mlcustinfo`;
CREATE TABLE `mlcustinfo` (
  `ci_id` int(11) NOT NULL auto_increment,
  `bookid` int(11),
  `di_history` varchar(2048) NOT NULL DEFAULT '',    -- [0,1] история создания и изменения документа
  `custominfo` varchar(2048) NOT NULL DEFAULT '',
   PRIMARY KEY  (`ci_id`),
   KEY `bookid` (`bookid`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

INSERT IGNORE INTO mlcustinfo SELECT NULL,`bookid`,'', `title1` FROM libbook WHERE title1<>'';

drop table IF EXISTS `libbook`;
drop table IF EXISTS `libfilename`;
drop table IF EXISTS `libfilenameold`;

update ignore mlbook set Deleted='0' where deleted & 1 = 0;
update ignore mlbook set Deleted='1' where deleted & 1 <> 0;

-- Авторы ------------------------------------------------------------------------------------------

DROP TABLE IF EXISTS `mlauthorname`;
CREATE TABLE `mlauthorname` (
  `authorid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `FirstName` varchar(99) NOT NULL DEFAULT '',
  `MiddleName` varchar(99) NOT NULL DEFAULT '',
  `LastName` varchar(99) NOT NULL DEFAULT '',
  `NickName` varchar(33) NOT NULL DEFAULT '',
  `FullName` varchar(200) NOT NULL default '',
  `Email` varchar(255) NOT NULL,
  `TotalCount` int(11)  NOT NULL default '0',
  `NormalCount` int(11)  NOT NULL default '0',  
  PRIMARY KEY (`authorid`),
  KEY `TotalCount` (`TotalCount`),
  KEY `NormalCount` (`NormalCount`),  
  KEY `FirstName` (`FirstName`(20)),
  KEY `LastName` (`LastName`(20)),
  KEY `FullName` (`FullName`(60))
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `mlauthor`;
CREATE TABLE `mlauthor` (
  `la_id` int(11) NOT NULL auto_increment,
  `bookid` int(10) unsigned NOT NULL DEFAULT '0',
  `authorid` int(10) unsigned NOT NULL DEFAULT '0',
  `role` binary(1) NOT NULL DEFAULT 'a' COMMENT 'a-автор,t-переводчик,i-иллюстратор',
  PRIMARY KEY (`la_id`),
  KEY `bookid` (`bookid`),
  KEY `authorid` (`authorid`),
  UNIQUE KEY `bookseq` (`bookid`,`authorid`,`role`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

INSERT IGNORE INTO mlauthorname SELECT `avtorid`,`FirstName`,`MiddleName`,`LastName`,`NickName`,TRIM(CONCAT_WS(" ",libavtorname.LastName,libavtorname.FirstName)) AS fullname,`Email`, NULL,NULL  FROM libavtorname JOIN libavtor USING(avtorid) WHERE role="a" OR role="r" OR role="s" OR role="t" GROUP BY avtorid;
INSERT IGNORE INTO mlauthor SELECT NULL,`bookid`,`avtorid`,`role`  FROM libavtorname JOIN libavtor USING(avtorid) WHERE role="a" OR role="r" OR role="s" OR role="t";

drop table if exists aaa;
create temporary table aaa (select authorid from mlauthor join mlauthorname using (authorid) where firstname="" and lastname="" and middlename="" and nickname="" group by authorid);
CREATE INDEX authorid ON aaa  (authorid);
delete from mlauthor where authorid in (select authorid from aaa);

drop table if exists aaa;
create temporary table aaa (select authorid from mlauthor join mlauthorname using (authorid) where firstname like "%автор%" or lastname like "%автор %" or middlename like "%автор%" group by authorid);
CREATE INDEX authorid ON aaa  (authorid);
delete from mlauthor where authorid in (select authorid from aaa);

drop table if exists aaa;
set @a:=(select min(authorid) from mlauthorname where Lastname="Автор неизвестен");
insert ignore into mlauthor(authorid,bookid,role) select @a, bookid,'a' from mlbook where bookid not in (select bookid from mlauthor);


drop table if exists aaa;
create temporary table aaa (select authorid from mlauthor group by authorid);
CREATE INDEX authorid ON aaa  (authorid);
delete from mlauthorname where authorid not in (select authorid from aaa);

drop table IF EXISTS `libavtorname`;
drop table IF EXISTS `libavtor`;

drop table if exists aaa;
create temporary table aaa (
select authorid,count(bookid) as tcount from mlbook join mlauthor using (bookid)   join mlauthorname using(authorid) group by authorid);
update ignore mlauthorname as a, aaa as b set totalcount=tcount where a.authorid=b.authorid;

drop table if exists aaa;
create temporary table aaa (
select authorid,count(bookid) as tcount from mlbook join mlauthor using(bookid) join  mlauthorname using (authorid) where deleted='0' group by authorid);
update ignore mlauthorname as a, aaa as b set normalcount=tcount where a.authorid=b.authorid;

-- Серии ------------------------------------------------------------------------------------------

DROP TABLE IF EXISTS `mlseqname`;
CREATE TABLE `mlseqname` (
  `seqid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `seqname` varchar(254) NOT NULL DEFAULT '',
  `TotalCount` int(11)  NOT NULL default '0',
  `NormalCount` int(11)  NOT NULL default '0',  
  PRIMARY KEY (`seqid`),
  KEY `TotalCount` (`TotalCount`),
  KEY `NormalCount` (`NormalCount`),  
  UNIQUE KEY `seqname` (`seqname`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `mlseq`;
CREATE TABLE `mlseq` (
  `sq_id` int(11) NOT NULL auto_increment,
  `bookid` int(11) NOT NULL,
  `seqid` int(11) NOT NULL,
  `seqnum` int(11) NOT NULL,
  PRIMARY KEY (`sq_id`),
  KEY (`bookid`),
  KEY `seqId` (`seqid`),
  UNIQUE KEY `bookseq` (`bookid`,`seqid`,`seqnum`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


INSERT IGNORE INTO mlseq SELECT NULL,`bookid`,`seqid`,`seqnumb` FROM libseqname JOIN libseq USING(seqid); 
INSERT IGNORE INTO mlseq SELECT NULL,`bookid`,`parent`,`seqnumb` FROM libseqname JOIN libseq USING(seqid) WHERE parent<>0; 
INSERT IGNORE INTO mlseqname SELECT libseqname.`seqid`,`seqname`,NULL,NULL FROM libseqname JOIN mlseq ON libseqname.seqid=mlseq.seqid;

drop table if exists aaa;
create temporary table aaa (
select seqid,count(bookid) as tcount from mlbook join mlseq using(bookid) join mlseqname using (seqid) group by seqid);
update ignore mlseqname as a, aaa as b set totalcount=tcount where a.seqid=b.seqid;

drop table if exists aaa;
create temporary table aaa (
select seqid,count(bookid) as tcount from mlbook join mlseq using(bookid) join mlseqname using (seqid) where deleted='0' group by seqid);
update ignore mlseqname as a, aaa as b set normalcount=tcount where a.seqid=b.seqid;

drop table IF EXISTS `libseqname`;
drop table IF EXISTS `libseq`;

-- Жанры ------------------------------------------------------------------------------------------

DROP TABLE IF EXISTS `mlgenrename`;
CREATE TABLE `mlgenrename` (
  `genreid` int(11) NOT NULL auto_increment,
  `parentgenreid` int(11) default NULL,
  `genrecode` varchar(30) NOT NULL default '',
  `genrenamerus` varchar(100) NOT NULL default '',
  `TotalCount` int(11)  NOT NULL default '0',
  `NormalCount` int(11)  NOT NULL default '0',  
  PRIMARY KEY  (`genreid`),
  KEY `parentgenreid` (`parentgenreid`),
  KEY `TotalCount` (`TotalCount`),
  KEY `NormalCount` (`NormalCount`),  
  KEY `genrecode` (`genrecode`),
  KEY `genrenamerus` (`genrenamerus`(50))
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `mlgenre`;
CREATE TABLE `mlgenre` (
  `gn_id` int(11) NOT NULL auto_increment,
  `bookid` int(10) unsigned NOT NULL DEFAULT '0',
  `genreid` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`gn_id`),
  KEY `bookid` (`bookid`),
  KEY `genreid` (`genreid`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

INSERT IGNORE INTO mlgenrename SELECT genreid,parentgenreid,genrecode,genredesc,NULL,NULL FROM libgenres;
INSERT IGNORE INTO mlgenre SELECT NULL,bookid,genreid FROM libgenre;

DROP TABLE IF EXISTS `libgenres`;
DROP TABLE IF EXISTS `libgenre`;

drop table if exists aaa;
create temporary table aaa (
select genreid,count(bookid) as tcount from mlbook join mlgenre using (bookid) join mlgenrename using (genreid) group by genreid);
update ignore mlgenrename as a, aaa as b set totalcount=tcount where a.genreid=b.genreid;

drop table if exists aaa;
create temporary table aaa (
select genreid,count(bookid) as tcount from mlbook join mlgenre using (bookid) join mlgenrename using (genreid)  where deleted='0' group by genreid);
update ignore mlgenrename as a, aaa as b set normalcount=tcount where a.genreid=b.genreid;

drop table if exists aaa;

SET character_set_client = @saved_cs_client; 
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
